#include "rat.h"

#include <iostream>

void rat::simplify()
{
  int min = p < q ? p : q;

  for (int i = 2; i <= min; ++i) {
    while (p % i == 0 && q % i == 0) {
      p /= i;
      q /= i;
    }
  }
}

void rat::add(const rat& o)
{
  p = p * o.q + o.p * q;
  q = q * o.q;

  simplify();
}

std::ostream& operator<<(
    std::ostream& o, const rat& r)
{
  o << r.get_p() << "/" << r.get_q();
  return o;
}

